﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using com.citizen.sdk;

namespace DeviceControlSample1
{
    public partial class fSearch : Form
    {
        public CitizenPrinterInfo[] PrinterList = new CitizenPrinterInfo[0];
        public string SelectedAddress = "";
        public int ConnectType = 0;

        public fSearch()
        {
            InitializeComponent();
        }

        private void fSearch_Load(object sender, EventArgs e)
        {
            listView1.Items.Clear();
            listView1.Columns.Add("Address", 100, HorizontalAlignment.Left);
            listView1.Columns.Add("", 200, HorizontalAlignment.Left);

            for (int i = 0; i < PrinterList.Length; i++)
            {
                string[] CLSs = new string[2];
                switch (ConnectType)
                {
                    case ESCPOSConst.CMP_PORT_WiFi:
                        CLSs[0] = PrinterList[i].ipAddress;
                        CLSs[1] = PrinterList[i].macAddress;
                        break;

                    case ESCPOSConst.CMP_PORT_USB:
                        CLSs[0] = PrinterList[i].deviceName;
                        CLSs[1] = PrinterList[i].printerModel;
                        break;

                    case ESCPOSConst.CMP_PORT_COM:
                        CLSs[0] = PrinterList[i].deviceName;
                        break;

                    case ESCPOSConst.CMP_PORT_LPT:
                        CLSs[0] = PrinterList[i].deviceName;
                        break;

                    case ESCPOSConst.CMP_PORT_Bluetooth:
                        CLSs[0] = PrinterList[i].deviceName;
                        CLSs[0] = PrinterList[i].bdAddress;
                        break;
                }

                listView1.Items.Add(new ListViewItem(CLSs));
            }

            listView1.Focus();
            listView1.Items[0].Selected = true;
        }

        private void BtnSelect_Click(object sender, EventArgs e)
        {
            if (listView1.SelectedItems.Count > 0)
            {
                SelectedAddress = listView1.SelectedItems[0].SubItems[0].Text;
                this.Close();               // フォームを閉じる
            }
        }

        private void listView1_DoubleClick(object sender, EventArgs e)
        {
            if (listView1.SelectedItems.Count > 0)
            {
                SelectedAddress = listView1.SelectedItems[0].SubItems[0].Text;
                this.Close();               // フォームを閉じる
            }
        }

    }
}
