﻿
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using com.citizen.sdk;
using System.Diagnostics;

namespace POSApplication
{
    public partial class Form1 : Form
    {
        // オーダーデータ
        struct OrderItem
        {
            public int Id;
            public String Name;
            public int Price;
            public int Num;
        };
        OrderItem[] orders = new OrderItem[]{
            new OrderItem(){Id=1001,Name="ハンバーガー",Price=300,Num=4},
            new OrderItem(){Id=1002,Name="ポテト",Price=200,Num=2},
            new OrderItem(){Id=1003,Name="オレンジジュース",Price=120,Num=2},
            new OrderItem(){Id=1004,Name="リンゴジュース",Price=150,Num=1},
            new OrderItem(){Id=1005,Name="コーラ",Price=100,Num=2},
        };

        // 連番用
        int count;


        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            DataTable dataTable1 = new DataTable("ComboBox");
            dataTable1.Columns.Add("Display", typeof(string));
            dataTable1.Columns.Add("Value", typeof(int));
            dataTable1.Rows.Add("WiFi", ESCPOSConst.CMP_PORT_WiFi);
            dataTable1.Rows.Add("USB", ESCPOSConst.CMP_PORT_USB);
            dataTable1.Rows.Add("COM", ESCPOSConst.CMP_PORT_COM);
            dataTable1.Rows.Add("LPT", ESCPOSConst.CMP_PORT_LPT);
            dataTable1.Rows.Add("Bluetooth", ESCPOSConst.CMP_PORT_Bluetooth);
            comboBox1.DataSource = dataTable1;
            comboBox1.DisplayMember = "Display";
            comboBox1.ValueMember = "Value";
            comboBox1.SelectedIndex = 0;

            listView1.Items.Clear();
            listView1.Columns.Add("Address", 100, HorizontalAlignment.Left);
            listView1.Columns.Add("", 255, HorizontalAlignment.Left);

            count = 0;  // 連番の初期化
        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            listView1.Items.Clear();
        }

        private void BtnSearch_Click(object sender, EventArgs e)
        {
            int i;
            int errCode;
            CitizenPrinterInfo[] list;
            ESCPOSPrinter printer;
            int type = (int)comboBox1.SelectedValue;

            listView1.Items.Clear();

            printer = new ESCPOSPrinter();
            list = printer.SearchCitizenPrinter(type, 5, out errCode);

            if (errCode != ESCPOSConst.CMP_SUCCESS)
            {
                showMessage(errCode);
                return;
            }

            for (i = 0; i < list.Length; i++)
            {
                string[] CLSs = new string[2];
                switch (type)
                {
                    case ESCPOSConst.CMP_PORT_WiFi:
                        CLSs[0] = list[i].ipAddress;
                        CLSs[1] = list[i].macAddress;
                        break;

                    case ESCPOSConst.CMP_PORT_USB:
                        CLSs[0] = list[i].deviceName;
                        CLSs[1] = list[i].printerModel;
                        break;

                    case ESCPOSConst.CMP_PORT_COM:
                        CLSs[0] = list[i].deviceName;
                        break;

                    case ESCPOSConst.CMP_PORT_LPT:
                        CLSs[0] = list[i].deviceName;
                        break;
                        
                    case ESCPOSConst.CMP_PORT_Bluetooth:
                        CLSs[0] = list[i].deviceName;
                        CLSs[0] = list[i].bdAddress;
                        break;
                }

                listView1.Items.Add(new ListViewItem(CLSs));
            }

            listView1.Focus();
            listView1.Items[0].Selected = true;
        }

        //レシートボタン
        private void BtnReceipt_Click(object sender, EventArgs e)
        {
            int result;
            int amount;
            int total_amount = 0;
            int total_Num = 0;
            int Tax = 0;
            int Total = 0;
            const double TAX_RATE = 0.08;
        
            int wordcount1 = 5;
            int wordcount2 = 16;
            int wordcount3 = 3;
            int wordcount4 = 8;
            int wordcount5 = 9;
            int wordcount6 = 7;

            bool checked3inch = radioButton2.Checked;

            if (checked3inch)
            {
                wordcount1 = 6;
                wordcount2 = 24;
                wordcount3 = 6;
                wordcount4 = 12;
                wordcount5 = 14;
                wordcount6 = 10;
            }

            // インスタンス生成
             ESCPOSPrinter printer = new ESCPOSPrinter();
            // 接続
            result = Connect(printer);

            if (result != ESCPOSConst.CMP_SUCCESS)
            {
                return;
            }

            // 日時を取得
            DateTime dat = DateTime.Now;
            string strDATE = dat.ToString("yyyy-MM-dd HH:mm:ss");
            // 連番を更新
            count = count + 1;
            // エンコード設定
            printer.SetEncoding("Shift_JIS");
            // 一括処理開始設定
            printer.TransactionPrint(ESCPOSConst.CMP_TP_TRANSACTION);

            // テキスト印刷
            printer.PrintBitmap(".\\shoplogo.bmp",
                 ESCPOSConst.CMP_BM_ASIS,
                 ESCPOSConst.CMP_ALIGNMENT_CENTER,
                 ESCPOSConst.CMP_BM_MODE_HT_DITHER | ESCPOSConst.CMP_BM_MODE_CMD_RASTER);

            printer.PrintText("\n毎度ありがとうございます\n" + "またのご来店お待ちしております\n",
                 ESCPOSConst.CMP_ALIGNMENT_CENTER, ESCPOSConst.CMP_FNT_BOLD,
                 ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

            printer.PrintText("ＡＢＣ店  " + strDATE + "\n\n",
                 ESCPOSConst.CMP_ALIGNMENT_CENTER, ESCPOSConst.CMP_FNT_DEFAULT,
                 ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

            for (int i = 0; i < orders.Length; i++)
            {
                printer.PrintPaddingText(orders[i].Id.ToString(), 
                    ESCPOSConst.CMP_FNT_DEFAULT, ESCPOSConst.CMP_TXT_1WIDTH, wordcount1, ESCPOSConst.CMP_SIDE_RIGHT);

                printer.PrintPaddingText(orders[i].Name, 
                    ESCPOSConst.CMP_FNT_DEFAULT, ESCPOSConst.CMP_TXT_1WIDTH, wordcount2, ESCPOSConst.CMP_SIDE_RIGHT);

                printer.PrintPaddingText(orders[i].Num.ToString(),
                    ESCPOSConst.CMP_FNT_DEFAULT, ESCPOSConst.CMP_TXT_1WIDTH, wordcount3, ESCPOSConst.CMP_SIDE_LEFT);

                amount = orders[i].Price * orders[i].Num;

                printer.PrintPaddingText("\\" + amount.ToString(), ESCPOSConst.CMP_FNT_DEFAULT, ESCPOSConst.CMP_TXT_1WIDTH, wordcount4, ESCPOSConst.CMP_SIDE_LEFT);

                printer.PrintNormal("\n");

                total_Num += orders[i].Num;

                total_amount += amount;  
            }
                
            Tax = (int)(total_amount * TAX_RATE);

            Total = (int)(total_amount + Tax);

            printer.PrintNormal("\n");

            printer.PrintPaddingText("税　抜",
                 ESCPOSConst.CMP_FNT_DEFAULT, ESCPOSConst.CMP_TXT_2WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT,
                 wordcount5, ESCPOSConst.CMP_SIDE_RIGHT);

            printer.PrintPaddingText("\\" + total_amount.ToString("0,000"), 
                ESCPOSConst.CMP_FNT_DEFAULT, ESCPOSConst.CMP_TXT_1HEIGHT, 
                wordcount6 * 2, ESCPOSConst.CMP_SIDE_LEFT);

            printer.PrintNormal("\n");

            printer.PrintPaddingText("消費税",
                 ESCPOSConst.CMP_FNT_DEFAULT, ESCPOSConst.CMP_TXT_2WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT,
                 wordcount5, ESCPOSConst.CMP_SIDE_RIGHT);

            printer.PrintPaddingText("\\" + Tax.ToString(), 
                ESCPOSConst.CMP_FNT_DEFAULT, ESCPOSConst.CMP_TXT_1HEIGHT, 
                wordcount6 * 2, ESCPOSConst.CMP_SIDE_LEFT);

            printer.PrintNormal("\n");

            printer.PrintPaddingText("合　計",
                 ESCPOSConst.CMP_FNT_DEFAULT, ESCPOSConst.CMP_TXT_2WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT,
                 wordcount5, ESCPOSConst.CMP_SIDE_RIGHT);

            printer.PrintPaddingText("\\" + Total.ToString("0,000"),
                ESCPOSConst.CMP_FNT_DEFAULT, ESCPOSConst.CMP_TXT_2WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT,
                wordcount6, ESCPOSConst.CMP_SIDE_LEFT);

            printer.PrintNormal("\n");

            printer.PrintText(total_Num  + "点     " + String.Format("{0:00000}", count) + "     田中\n\n",
                 ESCPOSConst.CMP_ALIGNMENT_CENTER, ESCPOSConst.CMP_FNT_DEFAULT,
                 ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

            // カット位置紙送り後、パーシャルカット
            printer.CutPaper(ESCPOSConst.CMP_CUT_PARTIAL_PREFEED);
            // 一括処理印刷指定
            result = printer.TransactionPrint(ESCPOSConst.CMP_TP_NORMAL);
            // 切断処理
            printer.Disconnect();

            showMessage(result);
        }
        

        //領収書ボタン
        private void BtnReceipt2_Click(object sender, EventArgs e)
        {
            int result;
            int amount = 0;
            int total_amount = 0;
            total_amount += amount;
            const double TAX_RATE = 1.08;
            int Total ;

            // インスタンス生成
            ESCPOSPrinter printer = new ESCPOSPrinter();
            // 接続
            result = Connect(printer);

            if (result != ESCPOSConst.CMP_SUCCESS)
            {
                return;
            }

            // 日時を取得
            DateTime dat = DateTime.Now;
            string strDATE = dat.ToString("yyyy年MM月dd日");
            // 連番を更新
            count = count + 1;
            // エンコード設定
            printer.SetEncoding("Shift_JIS");
            // 一括処理開始設定
            printer.TransactionPrint(ESCPOSConst.CMP_TP_TRANSACTION);

            //テキスト印刷
            printer.PrintText("領 収 書",
                 ESCPOSConst.CMP_ALIGNMENT_CENTER, ESCPOSConst.CMP_FNT_DEFAULT,
                 ESCPOSConst.CMP_TXT_2WIDTH | ESCPOSConst.CMP_TXT_2HEIGHT);

            printer.PrintText("  No." + String.Format("{0:00000}", count) + "\n\n" + strDATE,
                 ESCPOSConst.CMP_ALIGNMENT_CENTER, ESCPOSConst.CMP_FNT_DEFAULT,
                 ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

            printer.PrintText("\n\n            　　    様 \n\n",
                ESCPOSConst.CMP_ALIGNMENT_CENTER, ESCPOSConst.CMP_FNT_UNDERLINE | ESCPOSConst.CMP_FNT_BOLD,
                ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

            for (int i = 0; i < orders.Length; i++)
            {
                amount = orders[i].Price * orders[i].Num;
                total_amount += amount;
            }

            Total = (int)(total_amount * TAX_RATE);

            printer.PrintText("  \\" + String.Format("{0:#,0}", Total).PadLeft(10) + "- \n\n",
                ESCPOSConst.CMP_ALIGNMENT_CENTER, ESCPOSConst.CMP_FNT_UNDERLINE | ESCPOSConst.CMP_FNT_BOLD,
                ESCPOSConst.CMP_TXT_2WIDTH | ESCPOSConst.CMP_TXT_2HEIGHT);

            printer.PrintText("但し　　　  　  　     \n\n",
                ESCPOSConst.CMP_ALIGNMENT_CENTER, ESCPOSConst.CMP_FNT_UNDERLINE | ESCPOSConst.CMP_FNT_BOLD,
                ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

            printer.PrintTextPCFont("○○○株式会社",
                 ESCPOSConst.CMP_ALIGNMENT_CENTER, "HGP創英ﾌﾟﾚｾﾞﾝｽEB",
                 14, ESCPOSConst.CMP_FNT_DEFAULT, 100, 100);

            printer.PrintText("○○市○○○　×-××-××\n" + "TEL:XXXX-XX-XXXX\n" + "                       印\n\n",
                ESCPOSConst.CMP_ALIGNMENT_CENTER, ESCPOSConst.CMP_FNT_DEFAULT,
                ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

            // カット位置紙送り後、パーシャルカット
            printer.CutPaper(ESCPOSConst.CMP_CUT_PARTIAL_PREFEED);
            // 一括処理印刷指定
            result = printer.TransactionPrint(ESCPOSConst.CMP_TP_NORMAL);
            // 切断処理
            printer.Disconnect();

            showMessage(result);
        }

        //調理指示単品伝票ボタン
        private void BtnCooking_Click(object sender, EventArgs e)
        {
            int result;

            int wordcount1 = 18;
            int wordcount2 = 9;

            bool checked3inch = radioButton2.Checked;

            if (checked3inch)
            {
                wordcount1 = 26;
                wordcount2 = 13;
            }
            

            // インスタンス生成
            ESCPOSPrinter printer = new ESCPOSPrinter();
            // 接続
            result = Connect(printer);

            if (result != ESCPOSConst.CMP_SUCCESS)
            {
                return;
            }

            // 日時を取得
            DateTime dat = DateTime.Now;
            string strTIME = dat.ToString("HH:mm\n");
            // 連番を更新
            count = count + 1;
            // エンコード設定
            printer.SetEncoding("Shift_JIS");
            // 一括処理開始設定
            printer.TransactionPrint(ESCPOSConst.CMP_TP_TRANSACTION);
            // ブザーを鳴らす （ブザー対応プリンターが必要です）
            byte[] data = { 0x1b, 0x1e, 0x00, 0x1b, 0x1e, 0x00, 0x1b, 0x1e, 0x00 };
            printer.PrintData(data);

            // テキスト印刷
            for (int i = 0; i < orders.Length; i++)
            {
                printer.PrintText(orders[i].Num.ToString().PadLeft(2) + "  ", 
                    ESCPOSConst.CMP_ALIGNMENT_CENTER, ESCPOSConst.CMP_FNT_DEFAULT, ESCPOSConst.CMP_TXT_2WIDTH | ESCPOSConst.CMP_TXT_2HEIGHT);

                printer.PrintPaddingText(orders[i].Name,
                    ESCPOSConst.CMP_FNT_DEFAULT, ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_2HEIGHT,
                    wordcount1, ESCPOSConst.CMP_SIDE_RIGHT);

                printer.PrintNormal("\n");

                printer.PrintText("調理単品",
                     ESCPOSConst.CMP_ALIGNMENT_CENTER, ESCPOSConst.CMP_FNT_DEFAULT | ESCPOSConst.CMP_FNT_REVERSE,
                     ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

                printer.PrintPaddingText("A03", ESCPOSConst.CMP_FNT_DEFAULT,
                    ESCPOSConst.CMP_TXT_2WIDTH | ESCPOSConst.CMP_TXT_2HEIGHT,
                    wordcount2, ESCPOSConst.CMP_SIDE_LEFT);

                printer.PrintNormal("\n");

                printer.PrintText(String.Format("{0:00000}", count) + "    2名    田中    " + strTIME + "\n",
                     ESCPOSConst.CMP_ALIGNMENT_CENTER, ESCPOSConst.CMP_FNT_DEFAULT,
                     ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

               // 連番を更新
                count = count + 1;

                // カット位置紙送り後、パーシャルカット
                printer.CutPaper(ESCPOSConst.CMP_CUT_PARTIAL_PREFEED);
            }

            // 一括処理印刷指定
            result = printer.TransactionPrint(ESCPOSConst.CMP_TP_NORMAL);
            // 切断処理
            printer.Disconnect();

            showMessage(result);
        }


        //調理指示一枚伝票ボタン
        private void BtnServing_Click(object sender, EventArgs e)
        {
            int result;

            int wordcount1 = 30;
            int fontsize1 = ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT;

            bool checked3inch = radioButton2.Checked;

            if (checked3inch)
            {
                wordcount1 = 46;
                fontsize1 = ESCPOSConst.CMP_TXT_2WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT;
            }

            // インスタンス生成
            ESCPOSPrinter printer = new ESCPOSPrinter();
            // 接続
            result = Connect(printer);

            if (result != ESCPOSConst.CMP_SUCCESS)
            {
                return;
            }

            // 日時を取得
            DateTime dat = DateTime.Now;
            string strDATE = dat.ToString("HH:mm");
            // 連番を更新
            count = count + 1;
            // エンコード設定
            printer.SetEncoding("Shift_JIS");
            // 一括処理開始設定
            printer.TransactionPrint(ESCPOSConst.CMP_TP_TRANSACTION);
            // ブザーを鳴らす （ブザー対応プリンターが必要です）
            byte[] data = { 0x1b, 0x1e, 0x00, 0x1b, 0x1e, 0x00, 0x1b, 0x1e, 0x00 };
            printer.PrintData(data);

            // テキスト印刷
            printer.PrintText("調理一枚\n",
                 ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_REVERSE,
                 ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

            printer.PrintText("テーブル",
                 ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT,
                 ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

            printer.PrintPaddingText(" A03 ",
                ESCPOSConst.CMP_FNT_DEFAULT, fontsize1,
                7, ESCPOSConst.CMP_SIDE_LEFT);

            printer.PrintText("   伝　票 ",
                ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT,
                ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

            printer.PrintPaddingText(String.Format("{0:00000}", count) + "\n",
                ESCPOSConst.CMP_FNT_DEFAULT, fontsize1,
                8, ESCPOSConst.CMP_SIDE_LEFT);

            printer.PrintText("人　数  ",
                 ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT,
                 ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

            printer.PrintPaddingText(" 2 ",
                ESCPOSConst.CMP_FNT_DEFAULT, fontsize1,
                7, ESCPOSConst.CMP_SIDE_LEFT);

            printer.PrintText("   担　当 ",
                ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT,
                ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

            printer.PrintPaddingText("田中\n",
                ESCPOSConst.CMP_FNT_DEFAULT, fontsize1,
                8, ESCPOSConst.CMP_SIDE_LEFT);

            printer.PrintText("時　刻  ",
                 ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT,
                 ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

            printer.PrintPaddingText(" " + strDATE + " ",
                ESCPOSConst.CMP_FNT_DEFAULT, fontsize1,
                7, ESCPOSConst.CMP_SIDE_LEFT);

            printer.PrintText("   HT番号 ",
                ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT,
                ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

            printer.PrintPaddingText("HT001\n",
                ESCPOSConst.CMP_FNT_DEFAULT, fontsize1,
                8, ESCPOSConst.CMP_SIDE_LEFT);

            printer.SetRecLineSpacing(24);

            printer.PrintPaddingText("┏━┯━━┯━━━━━━━━━━━━━━━━━",
                            ESCPOSConst.CMP_FNT_DEFAULT, ESCPOSConst.CMP_TXT_1WIDTH, wordcount1, ESCPOSConst.CMP_SIDE_RIGHT);

            printer.PrintText("┓\n",
                    ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT,
                    ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

            printer.PrintPaddingText("┃　│数量│　　品　　名",
                            ESCPOSConst.CMP_FNT_DEFAULT, ESCPOSConst.CMP_TXT_1WIDTH, wordcount1, ESCPOSConst.CMP_SIDE_RIGHT);

            printer.PrintText("┃\n",
                 ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT,
                 ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

            printer.PrintPaddingText("┠─┼──┼─────────────────",
                            ESCPOSConst.CMP_FNT_DEFAULT, ESCPOSConst.CMP_TXT_1WIDTH, wordcount1, ESCPOSConst.CMP_SIDE_RIGHT);

            printer.PrintText("┨\n",
                    ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT,
                    ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

            for (int i = 0; i < orders.Length; i++)
            {
                printer.PrintText("┃",
                     ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT,
                     ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_2HEIGHT);

                printer.PrintText("□",
                     ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT,
                     ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

                printer.PrintText("│",
                    ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT,
                    ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_2HEIGHT);

                printer.PrintPaddingText(orders[i].Num.ToString(),
                     ESCPOSConst.CMP_FNT_DEFAULT,
                     ESCPOSConst.CMP_TXT_2WIDTH | ESCPOSConst.CMP_TXT_2HEIGHT,
                     2, ESCPOSConst.CMP_SIDE_LEFT);

                printer.PrintPaddingText("│" + orders[i].Name, 
                    ESCPOSConst.CMP_FNT_DEFAULT, ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_2HEIGHT, wordcount1 - 10, ESCPOSConst.CMP_SIDE_RIGHT);

                printer.PrintText("┃\n",
                     ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT,
                     ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_2HEIGHT);
            }

            printer.PrintPaddingText("┃　│    │                            ",
                ESCPOSConst.CMP_FNT_DEFAULT, ESCPOSConst.CMP_TXT_1WIDTH, wordcount1, ESCPOSConst.CMP_SIDE_RIGHT);

            printer.PrintText("┃\n",
                ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT,
                ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

            printer.PrintPaddingText("┃　│    │                            ",
                ESCPOSConst.CMP_FNT_DEFAULT, ESCPOSConst.CMP_TXT_1WIDTH, wordcount1, ESCPOSConst.CMP_SIDE_RIGHT);

            printer.PrintText("┃\n",
                ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT,
                ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

            printer.PrintPaddingText("┃　│    │                            ",
                ESCPOSConst.CMP_FNT_DEFAULT, ESCPOSConst.CMP_TXT_1WIDTH, wordcount1, ESCPOSConst.CMP_SIDE_RIGHT);

            printer.PrintText("┃\n",
                ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT,
                ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

            printer.PrintPaddingText("┗━┷━━┷━━━━━━━━━━━━━━━━━",
                            ESCPOSConst.CMP_FNT_DEFAULT, ESCPOSConst.CMP_TXT_1WIDTH, wordcount1, ESCPOSConst.CMP_SIDE_RIGHT);

            printer.PrintText("┛",
                 ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT,
                 ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

            printer.SetRecLineSpacing(34);

            // カット位置紙送り後、パーシャルカット
            printer.CutPaper(ESCPOSConst.CMP_CUT_PARTIAL_PREFEED);
            // 一括処理印刷指定
            result = printer.TransactionPrint(ESCPOSConst.CMP_TP_NORMAL);
            // 切断処理
            printer.Disconnect();

            showMessage(result);
        }

        //ゲスト伝票ボタン
        private void BtnCheck_Click(object sender, EventArgs e)
        {
            int result;
            int amount = 0;
            int total_amount = 0;
            int Tax = 0;
            int Total = 0;
            const double TAX_RATE = 0.08;
            //const double TAX_RATE2 = 1.08;
            
            bool checked3inch = radioButton2.Checked;

            // インスタンス生成
            ESCPOSPrinter printer = new ESCPOSPrinter();
            // 接続
            result = Connect(printer);

            if (result != ESCPOSConst.CMP_SUCCESS)
            {
                return;
            }

            // 日時を取得
            DateTime dat = DateTime.Now;
            string strDATE = dat.ToString("yyyy-MM-dd\n");
            string strTIME = dat.ToString("HH:mm\n");
            // 連番を更新
            count = count + 1;
            // エンコード設定
            printer.SetEncoding("Shift_JIS");
            // 一括処理開始設定
            printer.TransactionPrint(ESCPOSConst.CMP_TP_TRANSACTION);
            // ページモードの開始
            printer.PageModePrint(ESCPOSConst.CMP_PM_PAGE_MODE);
            //// ページモードのオフセットの指定
            printer.SetPageModeVerticalPosition(0);
            printer.SetPageModeHorizontalPosition(0);
            // ページモードの印刷方向の指定
            printer.SetPageModePrintDirection(ESCPOSConst.CMP_PD_LEFT_TO_RIGHT);

            if (checked3inch)
            {
                printer.SetPageModePrintArea("0,0,300,152");

                printer.PrintText("【新　規】\n",
                     ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT,
                     ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

                printer.SetPageModeVerticalPosition(32);
                printer.PrintText(strDATE,
                    ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT,
                    ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

                printer.SetPageModeVerticalPosition(64);
                printer.PrintBitmap(".\\shoplogo.bmp",
                    280, ESCPOSConst.CMP_ALIGNMENT_LEFT,
                    ESCPOSConst.CMP_BM_MODE_HT_DITHER | ESCPOSConst.CMP_BM_MODE_CMD_RASTER);

                printer.SetPageModePrintArea("320,0,210,152");

                printer.SetPageModeHorizontalPosition(0);
                printer.SetPageModeVerticalPosition(0);

                printer.PrintText("伝　票　　  " + String.Format("{0:00000}", count) + "\n",
                     ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT,
                     ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

                printer.SetPageModeVerticalPosition(32);
                printer.PrintText("テーブル　　A03\n",
                     ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT,
                     ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

                printer.SetPageModeVerticalPosition(64);
                printer.PrintText("人　数　　  2\n",
                    ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT,
                    ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

                printer.SetPageModeVerticalPosition(96);
                printer.PrintText("時　刻　　  " + strTIME,
                    ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT,
                    ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

                printer.SetPageModeVerticalPosition(128);
                printer.PrintText("担　当　　  田中\n",
                    ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT,
                    ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

                printer.PageModePrint(ESCPOSConst.CMP_PM_NORMAL);

                printer.SetRecLineSpacing(24);

                printer.PrintText("┏━━━━━━━━━━━━━┯━━┯━━━━━┓\n",
                     ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT,
                     ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

                printer.PrintText("┃　　　品　　　　　名　　　│数量│　金　額　┃\n",
                    ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT,
                    ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

                printer.PrintText("┠─────────────┼──┼─────┨\n",
                    ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT,
                    ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

                for (int i = 0; i < orders.Length; i++)
                {
                    printer.PrintText("┃",
                        ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT, ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_2HEIGHT);

                    printer.PrintPaddingText(orders[i].Id.ToString(), 
                        ESCPOSConst.CMP_FNT_DEFAULT, ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT, 6, ESCPOSConst.CMP_SIDE_RIGHT);

                    printer.PrintPaddingText(orders[i].Name, 
                        ESCPOSConst.CMP_FNT_DEFAULT, ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_2HEIGHT, 19, ESCPOSConst.CMP_SIDE_RIGHT);

                    printer.PrintPaddingText("│   " + orders[i].Num.ToString(), 
                        ESCPOSConst.CMP_FNT_DEFAULT, ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_2HEIGHT, 7, ESCPOSConst.CMP_SIDE_LEFT);

                    printer.PrintPaddingText("│       " + orders[i].Price.ToString(), 
                        ESCPOSConst.CMP_FNT_DEFAULT, ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_2HEIGHT, 12, ESCPOSConst.CMP_SIDE_LEFT);

                    printer.PrintText("┃\n", 
                        ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT, ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_2HEIGHT);

                    amount = orders[i].Price * orders[i].Num;

                    total_amount += amount;
                    
                }

                Tax = (int)(total_amount * TAX_RATE);

                Total = (int)(total_amount + Tax);


                printer.PrintText("┃　　　　　　　　　　　　　│　　│　　　　　┃\n",
                    ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT,
                    ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

                printer.PrintText("┣━━━━━┯━━━━┯━━┷━━┿━━━━━┫\n",
                    ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT,
                    ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

                printer.PrintText("┃　小　計　│",
                     ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT,
                     ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

                printer.PrintPaddingText(total_amount.ToString(), ESCPOSConst.CMP_FNT_DEFAULT, ESCPOSConst.CMP_TXT_1HEIGHT, 8, ESCPOSConst.CMP_SIDE_LEFT);

                printer.PrintText("│消　費　税│",
                     ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT,
                     ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

                printer.PrintPaddingText(Tax.ToString(), ESCPOSConst.CMP_FNT_DEFAULT, ESCPOSConst.CMP_TXT_1HEIGHT, 10, ESCPOSConst.CMP_SIDE_LEFT);

                printer.PrintText("┃\n",
                     ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT,
                     ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

                printer.PrintText("┠─────┴────┼─────┴─────┨\n",
                     ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT,
                     ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

                printer.PrintText("┃　合　計　          │",
                     ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT,
                     ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_2HEIGHT);

                printer.PrintPaddingText(Total.ToString(), ESCPOSConst.CMP_FNT_DEFAULT, ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_2HEIGHT, 22, ESCPOSConst.CMP_SIDE_LEFT);

                printer.PrintText("┃\n",
                     ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT,
                     ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_2HEIGHT);

                printer.PrintText("┗━━━━━━━━━━┷━━━━━━━━━━━┛\n",
                     ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT,
                     ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);
            }
            else
            {
                printer.SetPageModePrintArea("0,0,200,152");

                printer.PrintText("【新　規】\n",
                     ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT,
                     ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

                printer.SetPageModeVerticalPosition(32);
                printer.PrintText(strDATE,
                    ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT,
                    ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

                printer.SetPageModeVerticalPosition(72);
                printer.PrintBitmap(".\\shoplogo.bmp",
                    200, ESCPOSConst.CMP_ALIGNMENT_LEFT,
                    ESCPOSConst.CMP_BM_MODE_HT_DITHER | ESCPOSConst.CMP_BM_MODE_CMD_RASTER);

                printer.SetPageModePrintArea("210,0,170,152");

                printer.SetPageModeHorizontalPosition(0);
                printer.SetPageModeVerticalPosition(0);

                printer.PrintText("伝　票　 " + String.Format("{0:00000}", count) + "\n",
                     ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT,
                     ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

                printer.SetPageModeVerticalPosition(32);
                printer.PrintText("ﾃｰﾌﾞﾙ　  A03\n",
                     ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT,
                     ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

                printer.SetPageModeVerticalPosition(64);
                printer.PrintText("人　数　 2\n",
                    ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT,
                    ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

                printer.SetPageModeVerticalPosition(96);
                printer.PrintText("時　刻　 " + strTIME,
                    ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT,
                    ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

                printer.SetPageModeVerticalPosition(128);
                printer.PrintText("担　当　 田中\n",
                    ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT,
                    ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

                printer.PageModePrint(ESCPOSConst.CMP_PM_NORMAL);

                printer.SetRecLineSpacing(24);

                printer.PrintText("┏━━━━━━━━━┯━┯━━┓\n",
                     ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT,
                     ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

                printer.PrintText("┃　　品　　名　　　│数│金額┃\n",
                     ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT,
                     ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

                printer.PrintText("┠─────────┼─┼──┨\n",
                     ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT,
                     ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

                for (int i = 0; i < orders.Length; i++)
                {
                    printer.PrintText("┃", 
                        ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT, ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_2HEIGHT);

                    printer.PrintPaddingText(orders[i].Id.ToString(), 
                        ESCPOSConst.CMP_FNT_DEFAULT, ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT, 5, ESCPOSConst.CMP_SIDE_RIGHT);

                    printer.PrintPaddingText(orders[i].Name,
                        ESCPOSConst.CMP_FNT_DEFAULT, ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_2HEIGHT, 12, ESCPOSConst.CMP_SIDE_RIGHT);

                    printer.PrintPaddingText("│" + orders[i].Num.ToString(),
                        ESCPOSConst.CMP_FNT_DEFAULT, ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_2HEIGHT, 4, ESCPOSConst.CMP_SIDE_LEFT);

                    printer.PrintPaddingText("│ " + orders[i].Price.ToString(), 
                        ESCPOSConst.CMP_FNT_DEFAULT, ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_2HEIGHT, 7, ESCPOSConst.CMP_SIDE_LEFT);

                    printer.PrintText("┃\n", 
                        ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT, ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_2HEIGHT);

                    amount = orders[i].Price * orders[i].Num;

                    total_amount += amount;
                    
                }

                Tax = (int)(total_amount * TAX_RATE);

                Total = (int)(total_amount + Tax);

                printer.PrintText("┃　　　　　　　　　│　│　　┃\n",
                     ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT,
                     ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

                printer.PrintText("┣━━━┯━━━┯━┷━┿━━┫\n",
                     ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT,
                     ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

                printer.PrintText("┃小　計│",
                     ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT,
                     ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

                printer.PrintPaddingText(total_amount.ToString(), ESCPOSConst.CMP_FNT_DEFAULT, ESCPOSConst.CMP_TXT_1HEIGHT, 6, ESCPOSConst.CMP_SIDE_LEFT);

                printer.PrintText("│消費税│",
                     ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT,
                     ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

                printer.PrintPaddingText(Tax.ToString(), ESCPOSConst.CMP_FNT_DEFAULT, ESCPOSConst.CMP_TXT_1HEIGHT, 4, ESCPOSConst.CMP_SIDE_LEFT);

                printer.PrintText("┃\n",
                     ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT,
                     ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

                printer.PrintText("┠───┴───┼───┴──┨\n",
                     ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT,
                     ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

                printer.PrintText("┃　合　計　　　│",
                     ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT,
                     ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_2HEIGHT);

                printer.PrintPaddingText(Total.ToString(), ESCPOSConst.CMP_FNT_DEFAULT, ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_2HEIGHT, 12, ESCPOSConst.CMP_SIDE_LEFT);

                printer.PrintText("┃\n",
                     ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT,
                     ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_2HEIGHT);

                printer.PrintText("┗━━━━━━━┷━━━━━━┛\n",
                    ESCPOSConst.CMP_ALIGNMENT_LEFT, ESCPOSConst.CMP_FNT_DEFAULT,
                    ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);
            }
            
            printer.SetRecLineSpacing(34);

            printer.PrintText("毎度ありがとうございます\n ",
                     ESCPOSConst.CMP_ALIGNMENT_CENTER, ESCPOSConst.CMP_FNT_DEFAULT,
                     ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

            printer.PrintText("またのご来店お待ちしております\n\n",
                     ESCPOSConst.CMP_ALIGNMENT_CENTER, ESCPOSConst.CMP_FNT_DEFAULT,
                     ESCPOSConst.CMP_TXT_1WIDTH | ESCPOSConst.CMP_TXT_1HEIGHT);

            printer.PrintBarCode("123456789012",
                     ESCPOSConst.CMP_BCS_UPCA, 50, 2,
                     ESCPOSConst.CMP_ALIGNMENT_CENTER, ESCPOSConst.CMP_HRI_TEXT_NONE);
            
            // カット位置紙送り後、パーシャルカット
            printer.CutPaper(ESCPOSConst.CMP_CUT_PARTIAL_PREFEED);
            // 一括処理印刷指定
            result = printer.TransactionPrint(ESCPOSConst.CMP_TP_NORMAL);
            // 切断処理
            printer.Disconnect();

            showMessage(result);
        }

        void showMessage(int result)
        {
            string word;
            switch (result)
            {
                case ESCPOSConst.CMP_SUCCESS:
                    word = "正常終了";
                    break;

                case ESCPOSConst.CMP_E_CONNECTED:
                    word = "プリンターへ既に接続済みです。";
                    break;

                case ESCPOSConst.CMP_E_DISCONNECT:
                    word = "プリンターへ接続していません。";
                    break;

                case ESCPOSConst.CMP_E_NOTCONNECT:
                    word = "プリンターへ接続できませんでした。";
                    break;

                case ESCPOSConst.CMP_E_CONNECT_NOTFOUND:
                    word = "プリンター接続後の対応機種確認に失敗しました。";
                    break;

                case ESCPOSConst.CMP_E_CONNECT_OFFLINE:
                    word = "プリンター接続後のプリンター状態確認に失敗しました。";
                    break;

                case ESCPOSConst.CMP_E_USB_BIDIRECTIONAL:
                    word = "Windowsドライバーのステータス機能が有効でした。";
                    break;

                case ESCPOSConst.CMP_E_ILLEGAL:
                    word = "サポートされていない処理または無効なパラメータ値です。";
                    break;

                case ESCPOSConst.CMP_E_OFFLINE:
                    word = "プリンターがオフラインです。";
                    break;

                case ESCPOSConst.CMP_E_NOEXIST:
                    word = "指定のファイルが存在しません。";
                    break;

                case ESCPOSConst.CMP_E_FAILURE:
                    word = "要求された処理が実行できません。";
                    break;

                case ESCPOSConst.CMP_E_TIMEOUT:
                    word = "所定の時間が経過してもプリンターからの応答がありません。";
                    break;

                case ESCPOSConst.CMP_E_NO_LIST:
                    word = "プリンター検索にてプリンターが見つかりません。";
                    break;

                case ESCPOSConst.CMP_EPTR_COVER_OPEN:
                    word = "プリンターのカバーが開いています。";
                    break;

                case ESCPOSConst.CMP_EPTR_REC_EMPTY:
                    word = "用紙切れです。";
                    break;

                case ESCPOSConst.CMP_EPTR_BADFORMAT:
                    word = "指定されたファイルの書式がサポートされていません。";
                    break;

                case ESCPOSConst.CMP_EPTR_TOOBIG:
                    word = "指定されたビットマップのサイズが多きすぎます。";
                    break;

                default:
                    word = "その他のエラーです。";
                    break;
            }
                if (word == "正常終了")
                    MessageBox.Show(word + "  " + "(" + result.ToString() + ")", "結果", MessageBoxButtons.OK, MessageBoxIcon.Information);
                else
                    MessageBox.Show(word + "  " + "(" + result.ToString() + ")", "結果", MessageBoxButtons.OK, MessageBoxIcon.Error);   
        }

        int Connect(ESCPOSPrinter printer)
        {
            int Connectresult;
            int type = (int)comboBox1.SelectedValue;

            // シリアルポート設定 (シリアル接続のみ)
            if (type == ESCPOSConst.CMP_PORT_COM)
            {
                printer.SetCommProperties(ESCPOSConst.CMP_COM_BAUDRATE_9600,
                    ESCPOSConst.CMP_COM_PARITY_NONE,
                    ESCPOSConst.CMP_COM_HANDSHAKE_DTRDSR);
            }

            if (listView1.SelectedItems.Count == 0)
            {
                MessageBox.Show("アドレスが選択されていません。", "結果", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return ESCPOSConst.CMP_E_FAILURE;
            }

            Connectresult = printer.Connect(type, listView1.SelectedItems[0].Text);

            if (Connectresult != ESCPOSConst.CMP_SUCCESS)
            {
                showMessage(Connectresult);
            }

            return Connectresult;
        }

   　}
    
 }
